/*
 * Copyright (c) 2023 Xilinx
 * This package is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This package is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this package; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "gstamah264dec.h"
#include "gstamah265dec.h"
#include "gstamaav1dec.h"
#include "gstamah264enc.h"
#include "gstamah265enc.h"
#include "gstamaav1enc.h"
#include "gstamascaler.h"
#include "gstamadownload.h"
#include "gstamaupload.h"
#include "gstxrm.h"

static gboolean
plugin_init (GstPlugin * plugin)
{
  gboolean ret = FALSE;

  ret |= GST_ELEMENT_REGISTER (ama_h264dec, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_h265dec, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_av1dec, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_h264enc, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_h265enc, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_av1enc, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_scaler, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_download, plugin);
  ret |= GST_ELEMENT_REGISTER (ama_upload, plugin);

  gst_xrm_init ();

  return ret;
}

GST_PLUGIN_DEFINE (GST_VERSION_MAJOR,
    GST_VERSION_MINOR,
    ama,
    "Xilinx AMA plugin",
    plugin_init, "0.1", "LGPL", "Xilinx AMA", "http://xilinx.com/")
